SystemOrganization addCategory: #MakeMeASandwich!

Object subclass: #IngredientStep
	instanceVariableNames: 'ingredient amount unit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MakeMeASandwich'!

!IngredientStep methodsFor: 'comparing' stamp: 'EdouardKlein 5/8/2012 20:46'!
<= anIngredientStep 
	^self name <= anIngredientStep name.! !

!IngredientStep methodsFor: 'accessing' stamp: 'EdouardKlein 5/8/2012 20:20'!
amount: aByteString 
	amount := aByteString  asNumber.! !

!IngredientStep methodsFor: 'accessing' stamp: 'EdouardKlein 5/8/2012 20:18'!
ingredient: aByteString 
	ingredient := aByteString .! !

!IngredientStep methodsFor: 'accessing' stamp: 'EdouardKlein 5/11/2012 22:20'!
isLastStep
	^false.! !

!IngredientStep methodsFor: 'printing' stamp: 'EdouardKlein 5/12/2012 11:27'!
makefileRule
	|answer|
	answer := String new.
	answer := answer,self name,':'.
	answer := answer, TextConstants CR asString,'	'.
	answer := answer,'$(call INGREDIENT,  ', amount asString ,' ' , unit,' ',ingredient ,' )',TextConstants CR asString.
	^answer! !

!IngredientStep methodsFor: 'accessing' stamp: 'EdouardKlein 5/8/2012 20:41'!
name 
	^ingredient.! !

!IngredientStep methodsFor: 'accessing' stamp: 'EdouardKlein 5/8/2012 20:24'!
unit: aByteString 
	unit := aByteString.! !

Object subclass: #RecipeEditor
	instanceVariableNames: 'nodeList uicontent ingredientAmount unitList ingredientTextField unitTextField builder currentStepsDependencies stepName stepDirections isLastStep nameTextField servingsDropList bbuilder'
	classVariableNames: 'IngredientList UnitList'
	poolDictionaries: ''
	category: 'MakeMeASandwich'!

!RecipeEditor class methodsFor: 'class initialization' stamp: 'EdouardKlein 5/8/2012 20:21'!
initialize 
	"comment stating purpose of message"

	| temporary variable names |
	IngredientList := ListModel new list: SortedCollection new.
	UnitList := ListModel new list: SortedCollection new.! !

!RecipeEditor methodsFor: 'user interface' stamp: 'EdouardKlein 5/8/2012 20:02'!
addIngredient
	IngredientList add: ingredientTextField getText.! !

!RecipeEditor methodsFor: 'user interface' stamp: 'EdouardKlein 5/8/2012 20:45'!
addIngredientStep
	|step|
	step := IngredientStep new.
	step ingredient:(IngredientList list at:(IngredientList selectionIndex)).
	step amount: ingredientAmount getText.
	step unit: (UnitList list at:(UnitList selectionIndex)).
	(nodeList list) add: step.
	self changed: #nodeList.! !

!RecipeEditor methodsFor: 'accessing' stamp: 'EdouardKlein 5/12/2012 11:31'!
addStep
	|step|
	step := Step new.
	step title: stepName getText.
	step directions: stepDirections getText.
	step dependencies: currentStepsDependencies list.
	step isLastStep: isLastStep isSelected.
	nodeList add: step.
	self changed: #nodeList.
	stepName setText:''.
	stepDirections setText:''.
	currentStepsDependencies list: SortedCollection new.
	self changed: #currentStepsDependencies.! !

!RecipeEditor methodsFor: 'user interface' stamp: 'EdouardKlein 5/11/2012 19:51'!
addStepDependency
	currentStepsDependencies add: (nodeList  list at: (nodeList  selectionIndex)).
	self changed:#currentStepsDependencies .! !

!RecipeEditor methodsFor: 'user interface' stamp: 'EdouardKlein 5/8/2012 20:22'!
addUnit
	UnitList add: unitTextField getText.! !

!RecipeEditor methodsFor: 'accessing' stamp: 'EdouardKlein 5/11/2012 19:54'!
currentStepsDependencies 
	^currentStepsDependencies list collect: [:aNode| aNode name]! !

!RecipeEditor methodsFor: 'initialize-release' stamp: 'EdouardKlein 5/12/2012 18:02'!
initialize
	""
	
	nodeList := ListModel new list: SortedCollection new.
	bbuilder := UITheme builder.
	builder := (bbuilder newWindowFor:self title: 'Recipe Editor').
	currentStepsDependencies :=ListModel new list: SortedCollection new.! !

!RecipeEditor methodsFor: 'accessing' stamp: 'EdouardKlein 5/8/2012 20:41'!
nodeList
	^ nodeList list collect:[:aNode| aNode name]! !

!RecipeEditor methodsFor: 'user interface' stamp: 'EdouardKlein 5/12/2012 19:01'!
open
	builder addMorph:(builder newRow:{
		builder newTabGroup:{
			('Ingredient')->(
				builder newColumn:{
					builder newRow:{
						builder newColumn:{
							builder newListFor: IngredientList list:#list selected: #selectionIndex changeSelected: #selectionIndex: help: 'Liste des ingrdients'.
							builder newRow:{
								ingredientTextField := builder newTextEntryFor: (ValueHolder new contents: 'Nouvel Ingredient') getText: #contents setText: #contents: help: nil.
								builder newButtonFor: self action: #addIngredient getEnabled: nil  label: '+' help: 'Ajoute un ingredient  la liste des ingrdients disponibles'.
							}.
						}.
						ingredientAmount  := builder newTextEntryFor: (ValueHolder new contents: '1234') getText: #contents setText: #contents: help: 'Quantit'.
						builder newColumn:{
							builder newListFor: UnitList list: #list selected: #selectionIndex changeSelected: #selectionIndex: help: 'Units'.
							builder newRow:{
								unitTextField := builder newTextEntryFor: (ValueHolder new contents: 'Nouvelle Unit') getText: #contents setText: #contents: help: nil.
								builder newButtonFor: self action: #addUnit getEnabled: nil  label: '+' help: 'Ajoute une unit  la liste des units disponibles'.
							}.
						}.
					}.
					builder newButtonFor: self action: #addIngredientStep getEnabled: nil  label: 'Ingredient' help: 'Ajoute un ingredient'.
				}
			).
			('Etape')->(
				builder newColumn:{
					builder newColumn:{
						builder newRow:{
							stepName := builder newTextEntryFor: (ValueHolder new contents: 'Etape') getText: #contents setText: #contents: help: 'Nom de letape'.
							builder newListFor: self  list: #currentStepsDependencies  selected: #return0 changeSelected: #doNothing: help: 'Etapes dont celles-ci dpend'.
							builder newButtonFor: self action: #addStepDependency getEnabled: nil  label: '<-' help: 'Ajoute une dpendance a ltape courante'.
						}.
						stepDirections  := builder newTextEditorFor: (ValueHolder new contents: 'Mlanger') getText: #contents setText: #contents:.
						builder newRow:{
							isLastStep := builder  newCheckboxFor: (ValueHolder new contents: false) getSelected: #contents setSelected: #contents: label: 'Dernire Etape' help: 'all sera dpendant de cette tape'.
							builder newButtonFor: self action: #addStep getEnabled: nil  label: 'Etape' help: 'Ajoute une Etape'.
						}.
					}.
				}
			).
		}.
		builder newColumn:{
			builder newListFor: self list: #nodeList selected: #selectedNodeIndex changeSelected: #selectNodeAtIndex: help: 'Liste des tapes'.
			builder newGroupboxForAll: {
				nameTextField := builder newTextEntryFor: (ValueHolder new contents: 'Nom de la Recette') getText: #contents setText: #contents: help: 'Nom de la recette'.
				builder newLabelGroup: {
					'Nombre de parts'->(servingsDropList := builder newDropListFor: (ListModel new list: #(1 2 3 4 5 6 7 8 9 10)) list: #list getSelected: #selectionIndex setSelected: #selectionIndex: help: 'Parts pour les quantits proposes').
				}.
				builder newButtonFor: self action: #saveRecipe getEnabled: nil  label: 'Sauver' help: 'Sauve la recette dans un fichier Makefile'.
			}.
		}.
	}
	) fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@0 corner: 0 @ 0)).
	"(uicontent openInWindowLabeled: 'Editeur de recettes' )extent:400@400."
	bbuilder openModal: builder.! !

!RecipeEditor methodsFor: 'user interface' stamp: 'EdouardKlein 5/11/2012 19:56'!
return0
	^0.! !

!RecipeEditor methodsFor: 'printing' stamp: 'EdouardKlein 5/12/2012 12:26'!
saveRecipe
	| makefileString aStream |
	makefileString := String new.
	makefileString := 'RECIPE_NAME=',nameTextField getText,TextConstants CR asString .
	makefileString := makefileString ,'SERVINGS=',(servingsDropList list at: (servingsDropList listSelectionIndex)) asString,TextConstants CR asString .
	nodeList list do:[:aNode|
		makefileString := makefileString , aNode makefileRule.
		makefileString := makefileString ,TextConstants CR asString .
		].

	makefileString := makefileString ,'all: '.
	(nodeList list select:[:aNode| aNode isLastStep])do:[:aLastStep|
		makefileString := makefileString,aLastStep name,' '
		].
	makefileString := makefileString ,TextConstants CR asString .
	[FileSystem disk createDirectory:'/Users/edouard/Projets/Khambuze/Recipes/',nameTextField getText] on: DirectoryExists do:[:s|].
	aStream :=  (FileStream fileNamed: '/Users/edouard/Projets/Khambuze/Recipes/',nameTextField getText,'/Makefile').
	makefileString linesDo:[:l|
		aStream nextPutAll: l,String crlf.
		].
	aStream close.
	Transcript show: makefileString .
! !

!RecipeEditor methodsFor: 'accessing' stamp: 'EdouardKlein 5/8/2012 20:48'!
selectNodeAtIndex: aSmallInteger 
	| answer |
	answer := nodeList selectionIndex: aSmallInteger .
	self changed: #nodeList .
	^answer.! !

!RecipeEditor methodsFor: 'accessing' stamp: 'EdouardKlein 5/8/2012 18:07'!
selectedNodeIndex
	^ nodeList selectionIndex.! !

Object subclass: #Step
	instanceVariableNames: 'title directions dependencies lastStep'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MakeMeASandwich'!

!Step methodsFor: 'comparing' stamp: 'EdouardKlein 5/11/2012 20:09'!
<= aStep 
	^title <= aStep name.! !

!Step methodsFor: 'accessing' stamp: 'EdouardKlein 5/11/2012 20:04'!
dependencies: aSortedCollection 
	dependencies := aSortedCollection .! !

!Step methodsFor: 'accessing' stamp: 'EdouardKlein 5/11/2012 20:03'!
directions: aByteString 
	directions := aByteString .! !

!Step methodsFor: 'accessing' stamp: 'EdouardKlein 5/11/2012 22:20'!
isLastStep
	^lastStep .! !

!Step methodsFor: 'accessing' stamp: 'EdouardKlein 5/11/2012 20:22'!
isLastStep: aTrue 
	lastStep := aTrue .! !

!Step methodsFor: 'printing' stamp: 'EdouardKlein 5/12/2012 11:28'!
makefileRule
	|answer|
	answer := String new.
	answer := answer,self name,':'.
	dependencies do:[:dep|
		answer := answer,dep name,' '.
		].
	answer := answer, TextConstants CR asString,'	'.
	answer := answer,'$(call INSTRUCTIONS, "', directions ,'")',TextConstants CR asString.
	^answer! !

!Step methodsFor: 'accessing' stamp: 'EdouardKlein 5/11/2012 20:08'!
name
	^title.! !

!Step methodsFor: 'accessing' stamp: 'EdouardKlein 5/11/2012 20:07'!
title
	^ title! !

!Step methodsFor: 'accessing' stamp: 'EdouardKlein 5/11/2012 20:03'!
title: aByteString 
	title := aByteString .! !

ComposableModel subclass: #IngredientEditor
	instanceVariableNames: 'ingredientTextModel amountTextModel unitTextModel'
	classVariableNames: 'AmountListModel IngredientListModel UnitListModel'
	poolDictionaries: ''
	category: 'MakeMeASandwich'!

!IngredientEditor commentStamp: '<historical>' prior: 0!
An IngredientEditor is a composable spec to create a new IngredientStep. It is meant to be used in the RecipeEditor.

No entry points yet.

Outputs is the method #ingredientStep which gives the IngredientStep corresponding to what is currently selected in the interface.

TODO: Make the lists disabled if the corresponding textfield is non empty.
!

!IngredientEditor class methodsFor: 'class initialization' stamp: 'EdouardKlein 6/2/2012 17:16'!
initialize 
	IngredientListModel := ListComposableModel owner: self.
	UnitListModel := ListComposableModel owner: self.
	AmountListModel := ListComposableModel owner: self.! !

!IngredientEditor class methodsFor: 'as yet unclassified' stamp: 'EdouardKlein 6/2/2012 17:23'!
internSpec 
	^{ #ComposableSpec.
			#add:. {{#model. #ingredientListModel. #internSpec.}.
					#layout:. {#FrameLayout.
							#fractions:offsets:. (0@0 corner: 0.33@0.9). nil}}.
			#add:. {{#model. #ingredientTextModel. #internSpec.}. 
					#layout:. {#FrameLayout.
							#fractions:offsets:. (0@0.91 corner: 0.33@1). nil}}.
			#add:. {{#model. #amountListModel. #internSpec.}.
					#layout:. {#FrameLayout.
							#fractions:offsets:. (0.34@0 corner: 0.66@0.9). nil}}.
			#add:. {{#model. #amountTextModel. #internSpec.}. 
					#layout:. {#FrameLayout.
							#fractions:offsets:. (0.34@0.91 corner: 0.66@1). nil}}.
			#add:. {{#model. #unitListModel. #internSpec.}.
					#layout:. {#FrameLayout.
							#fractions:offsets:. (0.67@0 corner: 1@0.9). nil}}.
			#add:. {{#model. #unitTextModel. #internSpec.}. 
					#layout:. {#FrameLayout.
							#fractions:offsets:. (0.67@0.91 corner: 1@1). nil}}}.
							! !

!IngredientEditor methodsFor: 'accessing' stamp: 'EdouardKlein 6/2/2012 17:14'!
amountListModel 
	^AmountListModel ! !

!IngredientEditor methodsFor: 'accessing' stamp: 'EdouardKlein 6/2/2012 15:43'!
amountTextModel 
	^amountTextModel ! !

!IngredientEditor methodsFor: 'accessing' stamp: 'EdouardKlein 6/2/2012 16:00'!
ingredientListModel 
	^IngredientListModel  ! !

!IngredientEditor methodsFor: 'as yet unclassified' stamp: 'EdouardKlein 6/2/2012 17:46'!
ingredientStep
	|step|
	step := IngredientStep new.
	(ingredientTextModel textHolder contents = '') ifTrue: [
		step ingredient: IngredientListModel selectedItem.]
	 ifFalse:[
		step ingredient: ingredientTextModel textHolder contents.
		self newIngredient.
		ingredientTextModel textHolder contents:''.
		].
	(amountTextModel textHolder contents = '') ifTrue: [
		step amount: AmountListModel selectedItem.]
	 ifFalse:[
		step amount: amountTextModel textHolder contents.
		self newAmount.
		amountTextModel textHolder contents:''.
		].
	(unitTextModel textHolder contents = '') ifTrue: [
		step unit: UnitListModel selectedItem.]
	 ifFalse:[
		step unit: unitTextModel textHolder contents.
		self newUnit.
		unitTextModel textHolder contents:''.
		].
	^step.! !

!IngredientEditor methodsFor: 'accessing' stamp: 'EdouardKlein 6/2/2012 15:41'!
ingredientTextModel 
	^ingredientTextModel ! !

!IngredientEditor methodsFor: 'initialize' stamp: 'EdouardKlein 6/2/2012 17:26'!
initialize
	super initialize.
	ingredientTextModel := self instantiate: TextInputFieldModel.
	ingredientTextModel ghostText: 'New ingredient' ; autoAccept: true.
	unitTextModel := self instantiate: TextInputFieldModel.
	unitTextModel ghostText: 'New unit' ; autoAccept: true.
	amountTextModel := self instantiate: TextInputFieldModel.
	amountTextModel ghostText: 'New amount' ; autoAccept: true.
! !

!IngredientEditor methodsFor: 'as yet unclassified' stamp: 'EdouardKlein 6/2/2012 17:15'!
newAmount
	AmountListModel items: AmountListModel listHolder contents , {amountTextModel textHolder contents}! !

!IngredientEditor methodsFor: 'as yet unclassified' stamp: 'EdouardKlein 6/2/2012 17:36'!
newIngredient 
	IngredientListModel items: IngredientListModel listHolder contents , {ingredientTextModel textHolder contents}! !

!IngredientEditor methodsFor: 'as yet unclassified' stamp: 'EdouardKlein 6/2/2012 17:15'!
newUnit
	UnitListModel items: UnitListModel listHolder contents , {unitTextModel textHolder contents}! !

!IngredientEditor methodsFor: 'accessing' stamp: 'EdouardKlein 6/2/2012 17:14'!
unitListModel 
	^UnitListModel ! !

!IngredientEditor methodsFor: 'accessing' stamp: 'EdouardKlein 6/2/2012 15:43'!
unitTextModel 
	^unitTextModel ! !
RecipeEditor initialize!
IngredientEditor initialize!
